using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace ScanAppDemo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private ScanNet.ScannerComponent scannerComponent1;
		private Microsoft.WindowsCE.Forms.InputPanel inputPanel1;
		private System.Windows.Forms.TextBox textBarcodeBox;
		private System.Windows.Forms.Button triggerButton;
		private System.Windows.Forms.Button submitButton;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tabScanning;
		private System.Windows.Forms.TabPage tabSetup;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.ImageList imgConnectedList;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.PictureBox pictureBox2;
		private System.Windows.Forms.Button buttonConDis;
		private System.Windows.Forms.Button buttonDefault;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;

		private bool bScanned = false;
		private Queue qData = new Queue();
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Button buttonAddSystem;
		private System.Windows.Forms.TextBox textBoxSystem;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			pictureBox1.Image = imgConnectedList.Images[0];
			try
			{
				if( !scannerComponent1.IsConnected )
					scannerComponent1.ConnectScanner();

				if( scannerComponent1.IsConnected )
				{
					scannerComponent1.SetSystemSettings("U2RZ"); // default setting
					pictureBox1.Image = imgConnectedList.Images[1];
				}

			}
			catch( ScanNet.ScannerException ex )
			{
				MessageBox.Show( ex.Message );
			}
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.label1 = new System.Windows.Forms.Label();
			this.scannerComponent1 = new ScanNet.ScannerComponent();
			this.inputPanel1 = new Microsoft.WindowsCE.Forms.InputPanel();
			this.textBarcodeBox = new System.Windows.Forms.TextBox();
			this.triggerButton = new System.Windows.Forms.Button();
			this.submitButton = new System.Windows.Forms.Button();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabScanning = new System.Windows.Forms.TabPage();
			this.panel1 = new System.Windows.Forms.Panel();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.tabSetup = new System.Windows.Forms.TabPage();
			this.buttonAddSystem = new System.Windows.Forms.Button();
			this.label5 = new System.Windows.Forms.Label();
			this.textBoxSystem = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.buttonDefault = new System.Windows.Forms.Button();
			this.buttonConDis = new System.Windows.Forms.Button();
			this.panel2 = new System.Windows.Forms.Panel();
			this.label2 = new System.Windows.Forms.Label();
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.imgConnectedList = new System.Windows.Forms.ImageList();
			// 
			// label1
			// 
			this.label1.ForeColor = System.Drawing.Color.Yellow;
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Size = new System.Drawing.Size(152, 20);
			this.label1.Text = "Scan or type barcode";
			// 
			// scannerComponent1
			// 
			this.scannerComponent1.ComPort = 2;
			this.scannerComponent1.ReceivedBarcode += new ScanNet.ScannerComponent.ReceivedBarcodeEventHandler(this.scannerComponent1_ReceivedBarcode);
			// 
			// textBarcodeBox
			// 
			this.textBarcodeBox.BackColor = System.Drawing.SystemColors.Info;
			this.textBarcodeBox.Location = new System.Drawing.Point(8, 48);
			this.textBarcodeBox.Size = new System.Drawing.Size(208, 22);
			this.textBarcodeBox.Text = "";
			this.textBarcodeBox.LostFocus += new System.EventHandler(this.textBarcodeBox_LostFocus);
			this.textBarcodeBox.GotFocus += new System.EventHandler(this.textBarcodeBox_GotFocus);
			this.textBarcodeBox.TextChanged += new System.EventHandler(this.textBarcodeBox_TextChanged);
			// 
			// triggerButton
			// 
			this.triggerButton.Location = new System.Drawing.Point(8, 80);
			this.triggerButton.Size = new System.Drawing.Size(208, 40);
			this.triggerButton.Text = "Scan";
			this.triggerButton.Click += new System.EventHandler(this.triggerButton_Click);
			// 
			// submitButton
			// 
			this.submitButton.Location = new System.Drawing.Point(144, 152);
			this.submitButton.Text = "Submit";
			this.submitButton.Click += new System.EventHandler(this.submitButton_Click);
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabScanning);
			this.tabControl1.Controls.Add(this.tabSetup);
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(240, 272);
			this.tabControl1.SelectedIndexChanged += new System.EventHandler(this.tabControl1_SelectedIndexChanged);
			// 
			// tabScanning
			// 
			this.tabScanning.Controls.Add(this.panel1);
			this.tabScanning.Controls.Add(this.textBarcodeBox);
			this.tabScanning.Controls.Add(this.triggerButton);
			this.tabScanning.Controls.Add(this.submitButton);
			this.tabScanning.Location = new System.Drawing.Point(4, 4);
			this.tabScanning.Size = new System.Drawing.Size(232, 246);
			this.tabScanning.Text = "Scanning";
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.Color.SteelBlue;
			this.panel1.Controls.Add(this.label1);
			this.panel1.Controls.Add(this.pictureBox1);
			this.panel1.Size = new System.Drawing.Size(240, 32);
			// 
			// pictureBox1
			// 
			this.pictureBox1.Location = new System.Drawing.Point(200, 0);
			this.pictureBox1.Size = new System.Drawing.Size(32, 32);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
			// 
			// tabSetup
			// 
			this.tabSetup.Controls.Add(this.buttonAddSystem);
			this.tabSetup.Controls.Add(this.label5);
			this.tabSetup.Controls.Add(this.textBoxSystem);
			this.tabSetup.Controls.Add(this.label4);
			this.tabSetup.Controls.Add(this.label3);
			this.tabSetup.Controls.Add(this.buttonDefault);
			this.tabSetup.Controls.Add(this.buttonConDis);
			this.tabSetup.Controls.Add(this.panel2);
			this.tabSetup.Location = new System.Drawing.Point(4, 4);
			this.tabSetup.Size = new System.Drawing.Size(232, 246);
			this.tabSetup.Text = "Setup";
			// 
			// buttonAddSystem
			// 
			this.buttonAddSystem.Location = new System.Drawing.Point(144, 160);
			this.buttonAddSystem.Text = "Add";
			this.buttonAddSystem.Click += new System.EventHandler(this.buttonAddSystem_Click);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(16, 104);
			this.label5.Text = "Systemsetting(s)";
			// 
			// textBoxSystem
			// 
			this.textBoxSystem.Location = new System.Drawing.Point(16, 128);
			this.textBoxSystem.Size = new System.Drawing.Size(200, 22);
			this.textBoxSystem.Text = "";
			this.textBoxSystem.LostFocus += new System.EventHandler(this.textBoxSystem_LostFocus);
			this.textBoxSystem.GotFocus += new System.EventHandler(this.textBoxSystem_GotFocus);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 72);
			this.label4.Size = new System.Drawing.Size(208, 20);
			this.label4.Text = "Control Version:";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 48);
			this.label3.Size = new System.Drawing.Size(208, 20);
			this.label3.Text = "Module Version:";
			// 
			// buttonDefault
			// 
			this.buttonDefault.Location = new System.Drawing.Point(24, 216);
			this.buttonDefault.Text = "Default";
			this.buttonDefault.Click += new System.EventHandler(this.buttonDefault_Click);
			// 
			// buttonConDis
			// 
			this.buttonConDis.Location = new System.Drawing.Point(144, 216);
			this.buttonConDis.Text = "button1";
			this.buttonConDis.Click += new System.EventHandler(this.buttonConDis_Click);
			// 
			// panel2
			// 
			this.panel2.BackColor = System.Drawing.Color.SteelBlue;
			this.panel2.Controls.Add(this.label2);
			this.panel2.Controls.Add(this.pictureBox2);
			this.panel2.Size = new System.Drawing.Size(240, 32);
			// 
			// label2
			// 
			this.label2.ForeColor = System.Drawing.Color.Yellow;
			this.label2.Location = new System.Drawing.Point(8, 8);
			this.label2.Size = new System.Drawing.Size(152, 20);
			this.label2.Text = "Setup barcode module";
			// 
			// pictureBox2
			// 
			this.pictureBox2.Location = new System.Drawing.Point(200, 0);
			this.pictureBox2.Size = new System.Drawing.Size(32, 32);
			this.pictureBox2.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
			// 
			// imgConnectedList
			// 
			this.imgConnectedList.Images.Add(((System.Drawing.Image)(resources.GetObject("resource"))));
			this.imgConnectedList.Images.Add(((System.Drawing.Image)(resources.GetObject("resource1"))));
			this.imgConnectedList.ImageSize = new System.Drawing.Size(16, 16);
			// 
			// Form1
			// 
			this.Controls.Add(this.tabControl1);
			this.Menu = this.mainMenu1;
			this.Text = "Form1";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void scannerComponent1_ReceivedBarcode(object sender, ScanNet.ReceivedBarcodeEventArgs e)
		{
			bScanned = true;
			setbarcodetext( this.textBarcodeBox, e.Barcode );
			//textBarcodeBox.Text = e.Barcode;
		}

		private void setbarcodetext(Control sender, string newBarcode)
		{
			qData.Enqueue( newBarcode );
			sender.Invoke(new EventHandler(SetBarcodeText)); 
			
			Application.DoEvents();

		}

		public void SetBarcodeText(object sender, EventArgs e)
		{
			if( qData.Count == 0 ) 
				return;

			string line = null;
			lock(qData)
			{ 
				line = (string)qData.Dequeue(); 
			}
			Control c =(Control) sender;
			c.Text=line;
			c.Update();
		}

		private void textBarcodeBox_GotFocus(object sender, System.EventArgs e)
		{
			try
			{ 
				inputPanel1.Enabled = true;
			}
			catch( Exception ex)
			{
				MessageBox.Show( ex.Message );
			}
		}

		private void textBarcodeBox_LostFocus(object sender, System.EventArgs e)
		{
			try
			{
				inputPanel1.Enabled = false;
			}
			catch( Exception ex)
			{
				MessageBox.Show( ex.Message );
			}
		}

		private void triggerButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				scannerComponent1.EnableLaser();
			}
			catch( ScanNet.ScannerException ex )
			{
				if( ex.ErrorCode == (int)ScanNet.ScanErr.COMPORT_NOT_OPEN )
					pictureBox1.Image = imgConnectedList.Images[0];


				MessageBox.Show( "Error Code:"+ ex.ErrorCode.ToString() + "\r\n"+	ex.Message );
			}
		}

		private void submitButton_Click(object sender, System.EventArgs e)
		{
			if( textBarcodeBox.Text.Length == 0 )
			{
				MessageBox.Show("No barcode is entered or scanned.");
				return;
			}
			gotoQuantity();
		}


		private void textBarcodeBox_TextChanged(object sender, System.EventArgs e)
		{
			if( bScanned )
			{
				bScanned = false;
				gotoQuantity();
				// Start new thread to prevent blocking of the control.
				//qThread = new Thread( new ThreadStart( gotoQuantity)).Start();
				
			}
		}

		private void gotoQuantity()
		{
			try
			{
				QuantityForm quantityFrm = new QuantityForm();
				quantityFrm.barcodeTextBox.Text = textBarcodeBox.Text;
				quantityFrm.ShowDialog();
//				quantityFrm.Dispose();
//				MessageBox.Show("Quited Quantity");
//				this.BringToFront();
				textBarcodeBox.Text = "";
			}
			catch( Exception ex )
			{
				MessageBox.Show( ex.Message );
			}
	
		}

		private void contextMenuConnect_Popup(object sender, System.EventArgs e)
		{
			string messageString;
			if( scannerComponent1.IsConnected )
				messageString = "Do you want to disable the barcode reader?";
			else
				messageString = "Do you want to enable the barcode reader?";

			if( MessageBox.Show( messageString, "Question", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1 ) == DialogResult.Yes )
			{
				try
				{
					if( scannerComponent1.IsConnected )
						scannerComponent1.ConnectScanner();
					else
						scannerComponent1.DisconnectScanner();
				}
				catch( ScanNet.ScannerException ex )
				{
					MessageBox.Show( ex.Message );
				}
			}
		}

		private void tabControl1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if( tabControl1.SelectedIndex == 1 )
			{
				UpdateSetupTab();
			}
			else
			{
				pictureBox1.Image = imgConnectedList.Images[ scannerComponent1.IsConnected?1:0 ];
			}
		}

		private void UpdateSetupTab()
		{
			pictureBox2.Image = imgConnectedList.Images[ scannerComponent1.IsConnected?1:0 ];
			buttonConDis.Text = scannerComponent1.IsConnected?"Disconnect":"Connect";
			buttonDefault.Enabled = scannerComponent1.IsConnected;
			buttonAddSystem.Enabled = scannerComponent1.IsConnected;

			label3.Text = "Module Version: "+ (scannerComponent1.IsConnected?scannerComponent1.ModuleVersion:"????");
			label4.Text = "Control Version: "+ scannerComponent1.ControlVersion;
		}

		private void buttonConDis_Click(object sender, System.EventArgs e)
		{
			try
			{
				if( scannerComponent1.IsConnected )
					scannerComponent1.DisconnectScanner();
				else
					scannerComponent1.ConnectScanner();
				UpdateSetupTab();
			}
			catch( ScanNet.ScannerException ex )
			{
				MessageBox.Show( ex.Message );
			}
		}

		private void buttonDefault_Click(object sender, System.EventArgs e)
		{
			try
			{
				scannerComponent1.SetSystemSettings("U2RZ"); // Default with no suffix (0x0D)
			}
			catch( ScanNet.ScannerException ex )
			{
				MessageBox.Show( ex.Message );
			}
		}

		private void buttonAddSystem_Click(object sender, System.EventArgs e)
		{
			try
			{
				scannerComponent1.SetSystemSettings( textBoxSystem.Text );
			}
			catch( ScanNet.ScannerException ex )
			{	
				MessageBox.Show( ex.Message );
			}
		}

		private void textBoxSystem_GotFocus(object sender, System.EventArgs e)
		{
			try
			{ 
				inputPanel1.Enabled = true;
			}
			catch( Exception ex)
			{
				MessageBox.Show( ex.Message );
			}
		}

		private void textBoxSystem_LostFocus(object sender, System.EventArgs e)
		{
			try
			{ 
				inputPanel1.Enabled = false;
			}
			catch( Exception ex)
			{
				MessageBox.Show( ex.Message );
			}
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			scannerComponent1.DisconnectScanner();
		}
	}
}
